#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#include <tchar.h>
#include <windows.h>

#include <cstdio>

bool ConectarRecurso();
void DesconectarRecurso();

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
TCHAR szClassName[ ] = _T("CodeBlocksWindowsApp");

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default colour as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           _T("Conectando a unidades de red"),       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nCmdShow);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    FILE *fe;

    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
            ConectarRecurso();
            fe = fopen("x:\\estuvo_aqui.txt", "w");
            if(!fe) printf("Error!\n");
            else {
               fprintf(fe, "Conectando a unidades de red estuvo aqu.\n");
               fclose(fe);
            }
            break;
        case WM_DESTROY:
            DesconectarRecurso();
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

bool ConectarRecurso()
{
    NETRESOURCE nr;
    DWORD ret;
    const char *letra = "X:";
    const char *recurso = "\\\\localhost\\temp";
    const char *usuario = "usuario";
    const char *password = "password";
    bool conexionRemota;

    nr.dwType = RESOURCETYPE_ANY;
    nr.lpLocalName = (LPSTR)letra;
    nr.lpRemoteName = (LPSTR)recurso;
    nr.lpProvider = NULL;
    ret = WNetAddConnection2(&nr, password, usuario, 0);

    if(ret !=NO_ERROR)
        switch(ret) {
            case ERROR_ACCESS_DENIED: std::printf("Access to the network resource was denied."); break;
            case ERROR_ALREADY_ASSIGNED: std::printf("The local device specified by lpLocalName is already connected to a network resource."); break;
            case ERROR_BAD_DEV_TYPE: std::printf("The type of local device and the type of network resource do not match."); break;
            case ERROR_BAD_DEVICE: std::printf("The value specified by lpLocalName is invalid."); break;
            case ERROR_BAD_NET_NAME: std::printf("The value specified by lpRemoteName is not acceptable to any network resource provider. The resource name is invalid, or the named resource cannot be located."); break;
            case ERROR_BAD_PROFILE: std::printf("The user profile is in an incorrect format."); break;
            case ERROR_BAD_PROVIDER: std::printf("The value specified by lpProvider does not match any provider."); break;
            case ERROR_BAD_USERNAME: std::printf("The specified user name is not valid."); break;
            case ERROR_BUSY: std::printf("The router or provider is busy, possibly initializing. The caller should retry."); break;
            case ERROR_CANCELLED: std::printf("The attempt to make the connection was cancelled by the user through a dialog box from one of the network resource providers, or by a called resource."); break;
            case ERROR_CANNOT_OPEN_PROFILE: std::printf("The system is unable to open the user profile to process persistent connections."); break;
            case ERROR_DEVICE_ALREADY_REMEMBERED: std::printf("An entry for the device specified in lpLocalName is already in the user profile."); break;
            case ERROR_EXTENDED_ERROR: std::printf("A network-specific error occured. Call the WNetGetLastError function to get a description of the error."); break;
            case ERROR_INVALID_ADDRESS: std::printf("An attempt was made to access an invalid address."); break;
            case ERROR_INVALID_PARAMETER: std::printf("A parameter is incorrect."); break;
            case ERROR_INVALID_PASSWORD: std::printf("The specified password is invalid."); break;
            case ERROR_LOGON_FAILURE: std::printf("A logon failure because of an unknown user name or a bad password."); break;
            case ERROR_NO_NET_OR_BAD_PATH: std::printf("A network component has not started, or the specified name could not be handled."); break;
            case ERROR_NO_NETWORK: std::printf("There is no network present."); break;
            default: std::printf("Error %ld, desconocido", ret); break;
        }
    //   system("pause");
    conexionRemota = ((ret == NO_ERROR) || (ret == ERROR_ALREADY_ASSIGNED));
    return conexionRemota;
}

void DesconectarRecurso()
{
    const char *letra = "X:";

    WNetCancelConnection2(letra, 0, TRUE);
}
